InitSprite()
InitSprite3D()

InitKeyboard()
InitMouse()

UsePNGImageDecoder()

#Size = 12

XIncludeFile "Voxel.pbi"

Enumeration
	#Window
	#Sprite
	#Sprite3D
EndEnumeration

Procedure FPS()
	Static Time
	New = timeGetTime_()
	FPS = 1000/(New-Time)
	Time = New
	ProcedureReturn FPS
EndProcedure


OpenWindow(#Window, 0, 0, 1024, 768, "ScreenTitle", #PB_Window_SystemMenu|#PB_Window_ScreenCentered)
OpenWindowedScreen(WindowID(#Window), 0, 0, WindowWidth(#Window), WindowHeight(#Window), 0, 0, 0)

InitVoxel()

For Y = -#Size-2 To -#Size
For X = -#Size To #Size*2
For Z = -#Size To #Size*2
	If X*X+(Y+#Size*4-4)*(Y+#Size*4-4)+Z*Z <= #Size*#Size*9
		SetVoxel(X, Y, Z, RGBA(192+Random(63), 192+Random(63), 64, 255))
	ElseIf Y < -#Size
		SetVoxel(X, Y, Z, RGBA(64, 128+Random(63), 192+Random(63), 255))
	EndIf
Next
Next
Next

For X = -#Size To #Size
For Z = -#Size To #Size
	If X*X+Z*Z < #Size*#Size/4
		For Y = Random(3) To 0 Step -1
			SetVoxel(X, -#Size+Y, Z, RGBA(0, 192+Random(63), 64, 255))
		Next
	ElseIf X*X+Z*Z < #Size*#Size
		For Y = Random(1) To 0 Step -1
			SetVoxel(X, -#Size+Y, Z, RGBA(0, 192+Random(63), 64, 255))
		Next
	EndIf
Next
Next

For Y = -#Size To 0
	SetVoxel(0, Y, 0, RGBA(128+Random(32), 64+Random(32), 0, 255))
	SetVoxel(1, Y, 0, RGBA(128+Random(32), 64+Random(32), 0, 255))
	SetVoxel(0, Y, 1, RGBA(128+Random(32), 64+Random(32), 0, 255))
	SetVoxel(1, Y, 1, RGBA(128+Random(32), 64+Random(32), 0, 255))
Next
For Y = 0 To #Size
	SetVoxel(1+Y/2, Y, 1+Y/2, RGBA(128+Random(32), 64+Random(32), 0, 255))
	SetVoxel(1+Y/2, Y, 0-Y/2, RGBA(128+Random(32), 64+Random(32), 0, 255))
	SetVoxel(0-Y/2, Y, 1+Y/2, RGBA(128+Random(32), 64+Random(32), 0, 255))
	SetVoxel(0-Y/2, Y, 0-Y/2, RGBA(128+Random(32), 64+Random(32), 0, 255))
Next
For X = -#Size To #Size
For Z = -#Size To #Size
For Y = #Size/2 To #Size*2
	If (X*X+Y*Y/2+Z*Z) <= #Size*#Size*2 And Random(2) = 1
		If Random(6) = 1
			SetVoxel(X, Y, Z, RGBA(255, Random(63), 0, 255))
		Else
			SetVoxel(X, Y, Z, RGBA(0, 192+Random(63), 64, 255))
		EndIf
	EndIf
Next
Next
Next


Repeat
	
	Repeat
		
		Select WindowEvent()
			Case #PB_Event_CloseWindow
				End
			Case #Null
				Break
		EndSelect
		
	ForEver
	
	ClearScreen(0)
	
	If ExamineKeyboard()
		If KeyboardPushed(#PB_Key_Escape)
			End
		EndIf
		If KeyboardPushed(#PB_Key_A)
			VoxelInclude\Camera\Position\X - 0.1
		EndIf
		If KeyboardPushed(#PB_Key_D)
			VoxelInclude\Camera\Position\X + 0.1
		EndIf
	EndIf

	M3_Multiply(VoxelInclude\Camera\Orientation, M3_Rotation(Matrix3.Matrix3, -0.002, 0.01, 0.002))
	
	If Start3D()
		RenderVoxel()
		Stop3D()
	EndIf
	
	SetWindowTitle(#Window, "FPS: "+Str(FPS())+" | Voxel: "+Str(ListSize(VoxelInclude\Voxel()))+" | Faces: "+Str(VoxelInclude\Faces ))
	
	FlipBuffers()
	
ForEver
; IDE Options = PureBasic 5.00 Beta 2 (Windows - x64)
; CursorPosition = 119
; FirstLine = 61
; Folding = ---
; EnableXP
; EnableCompileCount = 31
; EnableBuildCount = 0